git-stash.shon commit git-branch: default to --track (34a3e69)
   1#!/bin/sh
   2# Copyright (c) 2007, Nanako Shiraishi
   3
   4USAGE='[ | list | show | apply | clear]'
   5
   6SUBDIRECTORY_OK=Yes
   7. git-sh-setup
   8require_work_tree
   9
  10TMP="$GIT_DIR/.git-stash.$$"
  11trap 'rm -f "$TMP-*"' 0
  12
  13ref_stash=refs/stash
  14
  15no_changes () {
  16        git diff-index --quiet --cached HEAD &&
  17        git diff-files --quiet
  18}
  19
  20clear_stash () {
  21        logfile="$GIT_DIR/logs/$ref_stash" &&
  22        mkdir -p "$(dirname "$logfile")" &&
  23        : >"$logfile"
  24}
  25
  26save_stash () {
  27        stash_msg="$1"
  28
  29        if no_changes
  30        then
  31                echo >&2 'No local changes to save'
  32                exit 0
  33        fi
  34        test -f "$GIT_DIR/logs/$ref_stash" ||
  35                clear_stash || die "Cannot initialize stash"
  36
  37        # state of the base commit
  38        if b_commit=$(git rev-parse --verify HEAD)
  39        then
  40                head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
  41        else
  42                die "You do not have the initial commit yet"
  43        fi
  44
  45        if branch=$(git symbolic-ref -q HEAD)
  46        then
  47                branch=${branch#refs/heads/}
  48        else
  49                branch='(no branch)'
  50        fi
  51        msg=$(printf '%s: %s' "$branch" "$head")
  52
  53        # state of the index
  54        i_tree=$(git write-tree) &&
  55        i_commit=$(printf 'index on %s' "$msg" |
  56                git commit-tree $i_tree -p $b_commit) ||
  57                die "Cannot save the current index state"
  58
  59        # state of the working tree
  60        w_tree=$( (
  61                GIT_INDEX_FILE="$TMP-index" &&
  62                export GIT_INDEX_FILE &&
  63
  64                rm -f "$TMP-index" &&
  65                git read-tree $i_tree &&
  66                git add -u &&
  67                git write-tree &&
  68                rm -f "$TMP-index"
  69        ) ) ||
  70                die "Cannot save the current worktree state"
  71
  72        # create the stash
  73        if test -z "$stash_msg"
  74        then
  75                stash_msg=$(printf 'WIP on %s' "$msg")
  76        else
  77                stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
  78        fi
  79        w_commit=$(printf '%s\n' "$stash_msg" |
  80                git commit-tree $w_tree -p $b_commit -p $i_commit) ||
  81                die "Cannot record working tree state"
  82
  83        git update-ref -m "$stash_msg" $ref_stash $w_commit ||
  84                die "Cannot save the current status"
  85        printf >&2 'Saved "%s"\n' "$stash_msg"
  86}
  87
  88have_stash () {
  89        git rev-parse --verify $ref_stash >/dev/null 2>&1
  90}
  91
  92list_stash () {
  93        have_stash || return 0
  94        git log --pretty=oneline -g "$@" $ref_stash |
  95        sed -n -e 's/^[.0-9a-f]* refs\///p'
  96}
  97
  98show_stash () {
  99        flags=$(git rev-parse --no-revs --flags "$@")
 100        if test -z "$flags"
 101        then
 102                flags=--stat
 103        fi
 104        s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
 105
 106        w_commit=$(git rev-parse --verify "$s") &&
 107        b_commit=$(git rev-parse --verify "$s^") &&
 108        git diff $flags $b_commit $w_commit
 109}
 110
 111apply_stash () {
 112        git diff-files --quiet ||
 113                die 'Cannot restore on top of a dirty state'
 114
 115        # current index state
 116        c_tree=$(git write-tree) ||
 117                die 'Cannot apply a stash in the middle of a merge'
 118
 119        s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
 120        w_tree=$(git rev-parse --verify "$s:") &&
 121        b_tree=$(git rev-parse --verify "$s^:") ||
 122                die "$*: no valid stashed state found"
 123
 124        eval "
 125                GITHEAD_$w_tree='Stashed changes' &&
 126                GITHEAD_$c_tree='Updated upstream' &&
 127                GITHEAD_$b_tree='Version stash was based on' &&
 128                export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
 129        "
 130
 131        if git-merge-recursive $b_tree -- $c_tree $w_tree
 132        then
 133                # No conflict
 134                a="$TMP-added" &&
 135                git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
 136                git read-tree --reset $c_tree &&
 137                git update-index --add --stdin <"$a" ||
 138                        die "Cannot unstage modified files"
 139                git-status
 140                rm -f "$a"
 141        else
 142                # Merge conflict; keep the exit status from merge-recursive
 143                exit
 144        fi
 145}
 146
 147# Main command set
 148case "$1" in
 149list)
 150        shift
 151        if test $# = 0
 152        then
 153                set x -n 10
 154                shift
 155        fi
 156        list_stash "$@"
 157        ;;
 158show)
 159        shift
 160        show_stash "$@"
 161        ;;
 162apply)
 163        shift
 164        apply_stash "$@"
 165        ;;
 166clear)
 167        clear_stash
 168        ;;
 169help | usage)
 170        usage
 171        ;;
 172*)
 173        if test $# -gt 0 && test "$1" = save
 174        then
 175                shift
 176        fi
 177        save_stash "$*" && git-reset --hard
 178        ;;
 179esac